// Copyright (c) 2006-2023  Made to Order Software Corp.  All Rights Reserved
//
// https://snapwebsites.org/project/serverplugins
// contact@m2osw.com
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#pragma once

// serverplugins
//
#include    <serverplugins/plugin.h>



namespace optional_namespace
{



/** \brief A test plugin class.
 *
 * All plugins must be derived from serverplugins::plugin and include the
 * SERVERPLUGINS_DEFAULTS() macro to generate the default header data.
 */
class testme
    : public serverplugins::plugin
{
public:
    SERVERPLUGINS_DEFAULTS(testme);

    virtual void        bootstrap();
    virtual std::string it_worked();

private:
};



} // optional_namespace namespace
// vim: ts=4 sw=4 et
